from datetime import datetime
from typing import List
from pydantic import BaseModel, Field
from typing import Optional


class Emoji(BaseModel):
    pass

class AccountField(BaseModel):
    name: Optional[str]
    value: Optional[str]
    verified_at: Optional[datetime]

class Account(BaseModel):
    account_id: str = Field(alias="id")
    username: str
    acct: str
    display_name: str
    locked: bool
    bot: bool
    discoverable: bool
    group: bool
    created_at: datetime
    note: str
    url: str
    avatar: str
    avatar_static: str
    header: str
    header_static: str
    followers_count: int
    following_count: int
    statuses_count: int
    last_status_at: datetime
    emojis: List[Emoji]
    fields: List[AccountField]
