from pydantic import BaseModel, Field
from typing import Optional

class MetaData(BaseModel):
    width: Optional[int] = None
    height: Optional[int] = None
    size: Optional[str] = None
    aspect: Optional[float] = None
    frame_rate: Optional[str] = None
    duration: Optional[float] = None
    bitrate: Optional[int] = None

class MetaCoordinates(BaseModel):
    x: float
    y: float

class Meta(BaseModel):
    length: Optional[str] = None
    duration: Optional[float] = None
    fps: Optional[int] = None
    size: Optional[str] = None
    width: Optional[int] = None
    height: Optional[int]= None
    aspect: Optional[float] = None
    audio_encode: Optional[str] = None
    audio_bitrate: Optional[str] = None
    audio_channels: Optional[str] = None
 
    original: MetaData
    small: MetaData
    focus: Optional[MetaCoordinates] = None

class MediaAttachment(BaseModel):
    media_id: str = Field(alias="id")
    media_type: str = Field(alias="type")
    url: str
    preview_url: str
    text_url: Optional[str]
    meta: Meta
    description: Optional[str]
    blurhash: str
