from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field
from mastodon.model.application import Application
from mastodon.model.account import Account
from mastodon.model.card import Card
from mastodon.model.media import MediaAttachment
from mastodon.model.poll import Poll


class Status(BaseModel):
    status_id: str = Field(alias="id")
    created_at: datetime
    in_reply_to_id: Optional[str]
    in_reply_to_account_id: Optional[str]
    sensitive: bool
    spoiler_text: str
    visibility: str
    language: Optional[str]
    uri: str
    url: Optional[str]
    replies_count: int
    reblogs_count: int
    favourites_count: int
    favourited: bool
    reblogged: bool
    muted: bool
    bookmarked: bool
    content: str
    reblog: Optional["Status"]
    application: Optional[Application] = None
    account: Account
    media_attachments: List[MediaAttachment]
    mentions: List
    tags: List
    emojis: List
    card: Optional[Card]
    poll: Optional[Poll]
