from loguru import logger
import requests


class Statuses():
    def __init__(self, configuration, authorization):
        self.config = configuration
        self.auth = authorization

    def favourite(self, status_id):
        server = self.config.get_value("server")
        url = f"https://{server}/api/v1/statuses/{status_id}/favourite"

        response = requests.post(url, headers=self.auth.get_auth_headers())

        logger.trace("JSON: {}".format(str(response.content)))
        if response.status_code == 200:
            return response.json()
        else:
            raise RuntimeError("Server returned {} {}".format(response.status_code, response.content))

    def unfavourite(self, status_id):
        server = self.config.get_value("server")
        url = f"https://{server}/api/v1/statuses/{status_id}/unfavourite"

        response = requests.post(url, headers=self.auth.get_auth_headers())

        logger.trace("JSON: {}".format(str(response.content)))
        if response.status_code == 200:
            return response.json()
        else:
            raise RuntimeError("Server returned {} {}".format(response.status_code, response.content))


    def reblog(self, status_id):
        server = self.config.get_value("server")
        url = f"https://{server}/api/v1/statuses/{status_id}/reblog"

        response = requests.post(url, headers=self.auth.get_auth_headers())

        logger.trace("JSON: {}".format(str(response.content)))
        if response.status_code == 200:
            return response.json()
        else:
            raise RuntimeError("Server returned {} {}".format(response.status_code, response.content))

    def unreblog(self, status_id):
        server = self.config.get_value("server")
        url = f"https://{server}/api/v1/statuses/{status_id}/unreblog"

        response = requests.post(url, headers=self.auth.get_auth_headers())

        logger.trace("JSON: {}".format(str(response.content)))
        if response.status_code == 200:
            return response.json()
        else:
            raise RuntimeError("Server returned {} {}".format(response.status_code, response.content))
