from mastodon.authorization import MastodonAuthorization
from mastodon.config import MastodonConfiguration
from loguru import logger
import requests


class Timelines():
    def __init__(self, configuration, authorization):
        self.config = configuration
        self.auth = authorization

    def home(self, min_id=None, max_id=None, since_id=None, limit=None):
        url = "https://"+self.config.get_value("server")+"/api/v1/timelines/home"

        parameters = dict()
        if(min_id is not None):
            parameters["min_id"] = min_id
        if(max_id is not None):
            parameters["max_id"] = max_id
        if(since_id is not None):
            parameters["since_id"] = since_id
        if(limit is not None):
            parameters["limit"] = limit

        response = requests.get(url, headers=self.auth.get_auth_headers(), params=parameters)
        logger.trace("JSON: {}".format(str(response.content)))
        if response.status_code == 200:
            return response.json()
        else:
            raise RuntimeError("Server returned {} {}".format(response.status_code, response.content))
